uniform vec2 res;
uniform Image terrain;

#ifdef VERTEX
vec4 position(mat4 transform_projection, vec4 vertex_position)
{
    // The order of operations matters when doing matrix multiplication.
    return transform_projection * vertex_position;
}
#endif

#ifdef PIXEL
vec4 effect(vec4 color, Image tex, vec2 texture_coords, vec2 screen_coords)
{

    vec2 step = 1.0/res;
    vec4 data = Texel(tex, texture_coords);
    if(data.r < 1.0/256) return data;
    float ground = Texel(terrain, texture_coords).r;
    data.r += ground;
    float counter = 0;
    vec4 blur = vec4(0,0,0,0);
    for (float i = -step.x/2; i <= step.x/2; i += step.x){
        for (float j = -step.y/2; j <= step.y/2; j += step.y){
            vec4 data1 = Texel(tex, texture_coords + vec2(i, j));
            if(data1.r > 1.0/256){
                float ground1 = Texel(terrain, texture_coords + vec2(i, j)).r;
                data1.r += ground1;
                counter +=1;
                blur +=data1;
            }
        }
    }
    
    blur = blur/counter;
    blur.r -= ground;
    data.r -= ground;

    return 0.90 * data + 0.1 * blur;
}
#endif