mapSizeX = 1024
mapSizeY = 1024

function love.load()
    fluidLayer = love.graphics.newCanvas(mapSizeX, mapSizeY, {format = "rgba16f"})
	fluidLayer:setWrap("clampzero")
    tmpBuffer = love.graphics.newCanvas(mapSizeX, mapSizeY, {format = "rgba16f"})
	tmpBuffer:setWrap("clampzero")
    canyon = love.graphics.newImage("canyon_heightmap2.png")
    love.graphics.setCanvas(fluidLayer)
    love.graphics.setColor(1, 0, 0)
    --love.graphics.circle("fill", mapSizeX/2 + 90, mapSizeY/2, 60, 16)
    --love.graphics.circle("fill", mapSizeX/2 - 90, mapSizeY/2, 60, 16)
    love.graphics.setBlendMode("add")
    for i = 1, 2 do
        love.graphics.circle("fill", mapSizeX/2, 20, 10, 16)
    end
    love.graphics.setBlendMode("alpha") 
    love.graphics.setColor(1,1,1)
    love.graphics.setCanvas()
    fluidsimShader = love.graphics.newShader("fluidsim.glsl")
    fluidShader = love.graphics.newShader("fluidrender.glsl")
    blurShader = love.graphics.newShader("blur.glsl")
    fluidsimShader:send("res", {mapSizeX, mapSizeY})
    fluidShader:send("res", {mapSizeX, mapSizeY})
    blurShader:send("res", {mapSizeX, mapSizeY})
    fluidsimShader:send("dt", 0.08)
    fluidsimShader:send("terrain", canyon)
    fluidShader:send("terrain", canyon)
    blurShader:send("terrain", canyon)
end

function love.update(dt)
    for i = 1, 2 do
        --3 fluid sim steps, 1 blur
        love.graphics.setShader(fluidsimShader)
        love.graphics.setCanvas(tmpBuffer)
        love.graphics.draw(fluidLayer)
        love.graphics.setCanvas(fluidLayer)
        love.graphics.draw(tmpBuffer)
        love.graphics.setCanvas(tmpBuffer)
        love.graphics.draw(fluidLayer)
        love.graphics.setShader(blurShader)
        love.graphics.setCanvas(fluidLayer)
        love.graphics.draw(tmpBuffer)
    end
--[[     love.graphics.setColor(0.01, 0, 0)
    love.graphics.setBlendMode("add")
    love.graphics.circle("fill", mapSizeX/2 + 60, mapSizeY/2, 10, 16)
    love.graphics.setBlendMode("alpha")  ]]
    love.graphics.setShader()
    love.graphics.setColor(1,1,1)
    love.graphics.setCanvas()
end

function love.draw()
    love.graphics.setShader(fluidShader)
    love.graphics.draw(fluidLayer,0,0,0,1)
    love.graphics.setShader()
end

function love.mousepressed( x, y, button, istouch, presses )
    if button == 1 then
        love.graphics.setCanvas(fluidLayer)
        love.graphics.setColor(1, 0, 0)
        love.graphics.setBlendMode("add")
        love.graphics.circle("fill", x, y, 10, 16)
        love.graphics.setBlendMode("alpha") 
        love.graphics.setColor(1,1,1)
        love.graphics.setCanvas()
    elseif button == 2 then
        love.graphics.setCanvas(fluidLayer)
        love.graphics.setColor(0, 0, 0)
        love.graphics.circle("fill", x, y, 20, 16)
        love.graphics.setColor(1,1,1)
        love.graphics.setCanvas()
    end
end